import java.util.Random;
import java.util.Timer;
import java.util.TimerTask;

class Flags {
   public Random r = new Random();
   public boolean thread_zero_wants_in = false;
   public boolean thread_one_wants_in = false;
}

class zero_starved extends TimerTask {
    public void run() {
      System.out.println("Zero: I'M STARVING!!");
      System.out.flush();
      System.exit(-1);
    }
}

class one_starved extends TimerTask {
    public void run() {
      System.out.println("One: I'M STARVING!!");
      System.out.flush();
      System.exit(-1);
    }
}

class thread_zero implements Runnable {

   private Flags f;
   private Timer t;
   private zero_starved tt;

   public thread_zero(Flags f) {
     this.f = f;
     t = new Timer();
     tt = new zero_starved();
     t.schedule(tt, 1000*5);
   }

   private void critical_region_zero() {
      tt.cancel();
      tt = null;
      t.purge();
      System.out.println("In CR Zero");
      tt = new zero_starved();
      t.schedule(tt, 1000*5);
   }

   private void other_stuff_zero() {
      System.out.println("In Other Stuff Zero");
   }

   public void run() {
     while (true) {
       f.thread_zero_wants_in = true;
       while (f.thread_one_wants_in) {
         f.thread_zero_wants_in = false;
         try {
             Thread.sleep(f.r.nextInt(2000));
         } catch (Exception e) {
         }
         f.thread_zero_wants_in = true;
       };
       System.out.println("Entering CR Zero");
       critical_region_zero();
       System.out.println("Leaving CR Zero");
       f.thread_zero_wants_in = false;
       other_stuff_zero();
     }
   }
}

class thread_one implements Runnable {

   private Flags f;
   private Timer t;
   private one_starved tt;

   public thread_one(Flags f) {
     this.f = f;
     t = new Timer();
     tt = new one_starved();
     t.schedule(tt, 1000*5);
   }

   private void critical_region_one() {
      tt.cancel();
      tt = null;
      t.purge();
      System.out.println("In CR One");
      tt = new one_starved();
      t.schedule(tt, 1000*5);
   }

   private void other_stuff_one() {
      System.out.println("In Other Stuff One");
   }

   public void run() {
     while (true) {
       f.thread_one_wants_in = true;
       while (f.thread_zero_wants_in) {
         f.thread_one_wants_in = false;
         try {
             Thread.sleep(f.r.nextInt(2000));
         } catch (Exception e) {
         }
         f.thread_one_wants_in = true;
       };
       System.out.println("Entering CR One");
       critical_region_one();
       System.out.println("Leaving CR One");
       f.thread_one_wants_in = false;
       other_stuff_one();
     }
   }
}

public class attempt_4 {

   public static void main(String[] args) {
     Flags  f    = new Flags();
     Thread zero = new Thread(new thread_zero(f));
     Thread one  = new Thread(new thread_one(f));

     zero.start();
     one.start();

   }

}
